Index: src/molecules.hpp
===================================================================
--- src/molecules.hpp	(revision 042f8283d213f623e8320856dfac9e6d55aa6800)
+++ src/molecules.hpp	(revision 36ec71f4484a1913d51cd83e623c516fde7c113f)
@@ -10,9 +10,11 @@
 
 // GSL headers
+#include <gsl/gsl_eigen.h>
+#include <gsl/gsl_heapsort.h>
+#include <gsl/gsl_linalg.h>
+#include <gsl/gsl_matrix.h>
 #include <gsl/gsl_multimin.h>
 #include <gsl/gsl_vector.h>
-#include <gsl/gsl_matrix.h>
-#include <gsl/gsl_eigen.h>
-#include <gsl/gsl_heapsort.h>
+#include <gsl/gsl_randist.h>
 
 // STL headers
@@ -156,5 +158,5 @@
 };
 
-ostream & operator << (ostream &ost, atom &a);
+ostream & operator << (ostream &ost, const atom &a);
 
 /** Bonds between atoms.
@@ -195,7 +197,13 @@
 };
 
-ostream & operator << (ostream &ost, bond &b);
+
+ostream & operator << (ostream &ost, const bond &b);
 
 class MoleculeLeafClass;
+
+
+#define MaxThermostats 6      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented 
+enum thermostats { None, Woodcock, Gaussian, Langevin, Berendsen, NoseHoover };   //!< Thermostat names for output
+
 
 /** The complete molecule.
@@ -254,6 +262,7 @@
   bool CenterInBox(ofstream *out);
   void CenterEdge(ofstream *out, Vector *max);
-  void CenterOrigin(ofstream *out, Vector *max);
-  void CenterGravity(ofstream *out, Vector *max);
+  void CenterOrigin(ofstream *out);
+  void CenterPeriodic(ofstream *out);
+  void CenterAtVector(ofstream *out, Vector *newcenter);
   void Translate(const Vector *x);
   void TranslatePeriodically(const Vector *trans);
@@ -261,17 +270,23 @@
   void Align(Vector *n);
   void Scale(double **factor);
-  void DetermineCenter(Vector &center);
+  void DeterminePeriodicCenter(Vector &center);
   Vector * DetermineCenterOfGravity(ofstream *out);
   Vector * DetermineCenterOfAll(ofstream *out);
-  void SetNameFromFilename(char *filename);
+  void SetNameFromFilename(const char *filename);
   void SetBoxDimension(Vector *dim);
   double * ReturnFullMatrixforSymmetric(double *cell_size);
   void ScanForPeriodicCorrection(ofstream *out);
+  bool VerletForceIntegration(ofstream *out, char *file, config &configuration);
+  void Thermostats(config &configuration, double ActualTemp, int Thermostat);
   void PrincipalAxisSystem(ofstream *out, bool DoRotate);
   double VolumeOfConvexEnvelope(ofstream *out, bool IsAngstroem);
   Vector* FindEmbeddingHole(ofstream *out, molecule *srcmol);
 
-  bool VerletForceIntegration(char *file, double delta_t, bool IsAngstroem);
-
+
+  double ConstrainedPotential(ofstream *out, atom **permutation, int start, int end, double *constants, bool IsAngstroem);
+  double MinimiseConstrainedPotential(ofstream *out, atom **&permutation, int startstep, int endstep, bool IsAngstroem);
+  void EvaluateConstrainedForces(ofstream *out, int startstep, int endstep, atom **PermutationMap, ForceMatrix *Force);
+  bool LinearInterpolationBetweenConfiguration(ofstream *out, int startstep, int endstep, const char *prefix, config &configuration); 
+	
   bool CheckBounds(const Vector *x) const;
   void GetAlignvector(struct lsq_params * par) const;
@@ -349,5 +364,5 @@
   bool AddHydrogenCorrection(ofstream *out, char *path);
   bool StoreForcesFile(ofstream *out, char *path, int *SortIndex);
-  bool insert(molecule *mol);
+  void insert(molecule *mol);
   molecule * ReturnIndex(int index);
   bool OutputConfigForListOfFragments(ofstream *out, config *configuration, int *SortIndex);
@@ -429,4 +444,15 @@
     char *databasepath;
 
+    int DoConstrainedMD;
+    int MaxOuterStep;
+    int Thermostat;
+    int *ThermostatImplemented;
+    char **ThermostatNames;
+    double TempFrequency;
+    double alpha;
+    double HooverMass;
+    double TargetTemp;
+    int ScaleTempStep;
+    
   private:
     char *mainname;
@@ -449,9 +475,6 @@
     int Seed;
 
-    int MaxOuterStep;
     int OutVisStep;
     int OutSrcStep;
-    double TargetTemp;
-    int ScaleTempStep;
     int MaxPsiStep;
     double EpsWannier;
@@ -501,4 +524,5 @@
   char *GetDefaultPath() const;
   void SetDefaultPath(const char *path);
+  void InitThermostats(ifstream *source);
 };
 
